    001    /* ========================================================================
    002     * JCommon : a free general purpose class library for the Java(tm) platform
    003     * ========================================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jcommon/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -----------------------------
    028     * BooleanObjectDescription.java
    029     * -----------------------------
    030     * (C)opyright 2003, 2004, by Thomas Morgner and Contributors.
    031     *
    032     * Original Author:  Thomas Morgner;
    033     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034     *
    035     * $Id: BooleanObjectDescription.java,v 1.3 2005/11/14 10:59:16 mungady Exp $
    036     *
    037     * Changes (from 19-Feb-2003)
    038     * -------------------------
    039     * 19-Feb-2003 : Added standard header and Javadocs (DG);
    040     * 29-Apr-2003 : Distilled from the JFreeReport project and moved into JCommon
    041     *
    042     */
    043
    044    package org.jfree.xml.factory.objects;
    045
    046    /**
    047     * An object-description for a <code>Boolean</code> object.
    048     *
    049     * @author Thomas Morgner
    050     */
    051    public class BooleanObjectDescription extends AbstractObjectDescription {
    052
    053        /**
    054         * Creates a new object description.
    055         */
    056        public BooleanObjectDescription() {
    057            super(Boolean.class);
    058            setParameterDefinition("value", String.class);
    059        }
    060
    061        /**
    062         * Creates a new <code>Boolean</code> based on the settings of this description object.
    063         *
    064         * @return A <code>Boolean</code>.
    065         */
    066        public Object createObject() {
    067            final String o = (String) getParameter("value");
    068            return Boolean.valueOf(o);
    069        }
    070
    071        /**
    072         * Sets the description object parameters to match the supplied object
    073         * (which should be an instance of <code>Boolean</code>.
    074         *
    075         * @param o  the object.
    076         * @throws ObjectFactoryException if there is a problem while reading the
    077         * properties of the given object.
    078         */
    079        public void setParameterFromObject(final Object o) throws ObjectFactoryException {
    080            if (!(o instanceof Boolean)) {
    081                throw new ObjectFactoryException("The given object is no java.lang.Boolean. ");
    082            }
    083            setParameter("value", String.valueOf(o));
    084        }
    085
    086        /**
    087         * Tests for equality.
    088         *
    089         * @param o  the object to test.
    090         *
    091         * @return A boolean.
    092         */
    093        public boolean equals(final Object o) {
    094            if (this == o) {
    095                return true;
    096            }
    097            if (!(o instanceof AbstractObjectDescription)) {
    098                return false;
    099            }
    100
    101            final AbstractObjectDescription abstractObjectDescription = (AbstractObjectDescription) o;
    102
    103            if (Boolean.TYPE.equals(abstractObjectDescription.getObjectClass())) {
    104                return true;
    105            }
    106            if (Boolean.class.equals(abstractObjectDescription.getObjectClass())) {
    107                return true;
    108            }
    109            return false;
    110        }
    111
    112        /**
    113         * Returns a hash code.
    114         *
    115         * @return A hash code.
    116         */
    117        public int hashCode() {
    118            return getObjectClass().hashCode();
    119        }
    120
    121    }